diff -ruN ../nakedmudv3.0/src/scripts/pychar.c src/scripts/pychar.c
--- ../nakedmudv3.0/src/scripts/pychar.c	Fri Oct  7 14:15:55 2005
+++ src/scripts/pychar.c	Sun Dec  4 20:03:07 2005
@@ -37,6 +37,7 @@
 //*****************************************************************************
 #include "../char_vars/char_vars.h"
 #include "../items/items.h"
+#include "../items/worn.h"
 
 
 
@@ -163,7 +164,7 @@
 
 PyObject *PyChar_getroom(PyChar *self, void *closure) {
   CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
-  if(ch != NULL) return Py_BuildValue("O", newPyRoom(charGetRoom(ch)));
+  if(ch != NULL) return Py_BuildValue("O", roomGetPyFormBorrowed(charGetRoom(ch)));
   else           return NULL;
 }
 
@@ -172,7 +173,7 @@
   if(ch == NULL)
     return NULL;
   else if(charGetLastRoom(ch) != NULL)
-    return Py_BuildValue("O", newPyRoom(charGetLastRoom(ch)));
+    return Py_BuildValue("O", roomGetPyFormBorrowed(charGetLastRoom(ch)));
   else {
     Py_INCREF(Py_None);
     return Py_None;
@@ -216,7 +217,7 @@
   else if(charGetFurniture(ch) == NULL)
     return Py_None;
   else 
-    return Py_BuildValue("i", newPyObj(charGetFurniture(ch)));
+    return Py_BuildValue("O", objGetPyFormBorrowed(charGetFurniture(ch)));
 }
 
 PyObject *PyChar_getuid(PyChar *self, void *closure) {
@@ -241,9 +242,28 @@
   
   // for each obj in the inventory, add it to the Python list
   ITERATE_LIST(obj, inv_i)
-    PyList_Append(list, newPyObj(obj));
+    PyList_Append(list, objGetPyFormBorrowed(obj));
   deleteListIterator(inv_i);
-  return Py_BuildValue("O", list);
+  PyObject *retval = Py_BuildValue("O", list);
+  Py_DECREF(list);
+  return retval;
+}
+
+PyObject *PyChar_geteq(PyChar *self, PyObject *args) {
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+  if(ch == NULL)
+    return NULL;
+
+  PyObject      *list = PyList_New(0);
+  LIST      *equipped = bodyGetAllEq(charGetBody(ch));
+  LIST_ITERATOR *eq_i = newListIterator(equipped);
+  OBJ_DATA        *eq = NULL;
+  ITERATE_LIST(eq, eq_i) {
+    PyList_Append(list, objGetPyFormBorrowed(eq));
+  } deleteListIterator(eq_i);
+  PyObject *retval = Py_BuildValue("O", list);
+  Py_DECREF(list);
+  return retval;
 }
 
 
@@ -384,6 +404,7 @@
   CHAR_DATA *ch;
   PYCHAR_CHECK_CHAR_EXISTS(self->uid, ch);
   charSetRace(ch, race);
+  charResetBody(ch);
   return 0;
 }
 
@@ -606,7 +627,10 @@
 
   CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
   if(ch) {
-    do_cmd(ch, act, FALSE);
+    // do not send the actual act - if we edit it, things go awry
+    char *working_act = strdupsafe(act);
+    do_cmd(ch, working_act, FALSE);
+    free(working_act);
     return Py_BuildValue("i", 1);
   }
   else {
@@ -825,7 +849,7 @@
   }
 
   // try equipping the object. If we fail, put it back wherever it came from
-  if(!objIsType(obj, "worn") || !try_equip(ch, obj, pos)) {
+  if(!objIsType(obj, "worn") || !try_equip(ch, obj, pos,wornGetPositions(obj))){
     if(old_room != NULL)
       obj_to_room(obj, old_room);
     else if(old_cont != NULL)
@@ -833,7 +857,7 @@
     else if(old_carrier != NULL)
       obj_to_char(obj, old_carrier);
     else if(old_wearer != NULL)
-      try_equip(ch, obj, old_pos);
+      try_equip(ch, obj, old_pos, NULL);
     PyErr_Format(PyExc_StandardError,
 		 "Character is already equipped in all possible positions!");
     return NULL;
@@ -1049,7 +1073,9 @@
     printf("Data is NULL for %s!!\r\n", keyword);
     data = Py_None;
   }
-  return Py_BuildValue("O", data);
+  PyObject *retval = Py_BuildValue("O", data);
+  Py_DECREF(data);
+  return retval;
 }
 
 
@@ -1208,10 +1234,84 @@
   }
 
   // create a python object for the new char, and return it
-  PyChar *py_mob = (PyChar *)newPyChar(mob);
-  return Py_BuildValue("O", py_mob);
+  return Py_BuildValue("O", charGetPyFormBorrowed(mob));
 }
 
+PyObject *PyChar_find_char_key(PyObject *self, PyObject *args) {
+  CHAR_DATA     *ch = NULL;
+  PyObject    *pych = NULL;
+  LIST       *where = mobile_list;
+  PyObject *pywhere = NULL;
+  char         *key = NULL;
+  bool     must_see = TRUE;
+  bool     multiple = FALSE;
+  ROOM_DATA   *room = NULL;
+
+  // figure out our arguments
+  if(!PyArg_ParseTuple(args, "Os|Obb",&pych,&key,&pywhere,&must_see,&multiple)){
+    PyErr_Format(PyExc_TypeError, "Invalid arguments supplied to find_char");
+    return NULL;
+  }
+
+  // make sure ch exists, if we supplied one
+  if(pych == Py_None)
+    ch = NULL;
+  else if(PyChar_Check(pych)) {
+    ch = PyChar_AsChar(pych);
+    if(ch == NULL) {
+      PyErr_Format(PyExc_StandardError, "character does not exist");
+      return NULL;
+    }
+  }
+  else {
+    PyErr_Format(PyExc_TypeError, "first arg must be a Char, or None");
+    return NULL;
+  }
+
+  // figoure out our room if we supply one
+  if(pywhere != NULL) {
+    if(PyRoom_Check(pywhere))
+      room = PyRoom_AsRoom(pywhere);
+    else if(PyString_Check(pywhere))
+      room = worldGetRoom(gameworld, 
+			  get_fullkey_relative(PyString_AsString(pywhere),
+					       get_script_locale()));
+    else if(pywhere == Py_None)
+      room = NULL;
+    else {
+      PyErr_Format(PyExc_TypeError, "search scope must be a room or room key");
+      return NULL;
+    }
+  }
+
+  // if we've got a room, look in it
+  if(room != NULL)
+    where = roomGetCharacters(room);
+
+  // do the searching for a single thing
+  if(multiple == FALSE) {
+    CHAR_DATA *found = find_char(ch, where, 1, NULL, 
+				 get_fullkey_relative(key, get_script_locale()),
+				 must_see);
+    return Py_BuildValue("O", (found ? charGetPyFormBorrowed(found) : Py_None));
+  }
+  // search for multiple occurences
+  else {
+    LIST *found = find_all_chars(ch, where, NULL,
+				 get_fullkey_relative(key, get_script_locale()),
+				 must_see);
+    PyObject         *list = PyList_New(0);
+    LIST_ITERATOR *found_i = newListIterator(found);
+    CHAR_DATA   *one_found = NULL;
+    ITERATE_LIST(one_found, found_i) {
+      PyList_Append(list, charGetPyForm(one_found));
+    } deleteListIterator(found_i);
+    deleteList(found);
+    PyObject *retval = Py_BuildValue("O", list);
+    Py_DECREF(list);
+    return retval;
+  }
+}
 
 PyObject *PyChar_count_mobs(PyObject *self, PyObject *args) {
   LIST            *list = NULL;
@@ -1261,9 +1361,11 @@
   LIST_ITERATOR *ch_i = newListIterator(mobile_list);
   CHAR_DATA       *ch = NULL;
   ITERATE_LIST(ch, ch_i)
-    PyList_Append(list, newPyChar(ch));
+    PyList_Append(list, charGetPyForm(ch));
   deleteListIterator(ch_i);
-  return Py_BuildValue("O", list);
+  PyObject *retval = Py_BuildValue("O", list);
+  Py_DECREF(list);
+  return retval;
 }
 
 PyObject *PyChar_all_sockets(PyObject *self) {
@@ -1273,9 +1375,11 @@
   ITERATE_LIST(sock, sock_i) {
     // only add sockets with attached characters who are in game
     if(socketGetChar(sock) && charGetRoom(socketGetChar(sock)))
-      PyList_Append(list, newPyChar(socketGetChar(sock)));
+      PyList_Append(list, charGetPyForm(socketGetChar(sock)));
   } deleteListIterator(sock_i);
-  return Py_BuildValue("O", list);
+  PyObject *retval = Py_BuildValue("O", list);
+  Py_DECREF(list);
+  return retval;
 }
 
 PyMethodDef char_module_methods[] = {
@@ -1288,6 +1392,9 @@
   { "count_mobs", PyChar_count_mobs, METH_VARARGS,
     "count how many occurances of a mobile there are in the specified scope. "
     "prototype or name can be used." },
+  { "find_char_key", PyChar_find_char_key, METH_VARARGS,
+    "finds a character (or group of chars) by their prototype. Finding by "
+    "keywords is done with generic_find()" },
   {NULL, NULL, 0, NULL}  /* Sentinel */
 };
 
@@ -1333,6 +1440,8 @@
 		      "returns a list of objects in the char's inventory");
   PyChar_addGetSetter("objs", PyChar_getinv, NULL,
 		      "returns a list of objects in the char's inventory");
+  PyChar_addGetSetter("eq",   PyChar_geteq,  NULL,
+		      "returns a list of the character's equipment");
   PyChar_addGetSetter("name", PyChar_getname, PyChar_setname,
 		      "handle the character's name");
   PyChar_addGetSetter("mname", PyChar_getmname, PyChar_setmname,
@@ -1399,6 +1508,8 @@
   PyChar_addMethod("hasvar", PyChar_hasvar, METH_VARARGS,
 		   "return whether or not the character has a given variable.");
   PyChar_addMethod("deletevar", PyChar_deletevar, METH_VARARGS,
+		   "delete a variable from the character's variable table.");
+  PyChar_addMethod("delvar", PyChar_deletevar, METH_VARARGS,
 		   "delete a variable from the character's variable table.");
   PyChar_addMethod("equip", PyChar_equip, METH_VARARGS,
 		   "equips a character with the given item. Removes the item "
diff -ruN ../nakedmudv3.0/src/scripts/pyevent.c src/scripts/pyevent.c
--- ../nakedmudv3.0/src/scripts/pyevent.c	Fri Oct  7 14:15:55 2005
+++ src/scripts/pyevent.c	Sun Dec  4 20:03:07 2005
@@ -151,6 +151,7 @@
    "itself to the event queue after completion."},
   {"interrupt_events_involving",  PyEvent_interrupt_event, METH_VARARGS,
    "Interrupt all of the events involving the given object, room, or char."},
+  {NULL, NULL, 0, NULL}  /* Sentinel */
 };
 
 
diff -ruN ../nakedmudv3.0/src/scripts/pyexit.c src/scripts/pyexit.c
--- ../nakedmudv3.0/src/scripts/pyexit.c	Fri Oct  7 14:15:55 2005
+++ src/scripts/pyexit.c	Sun Dec  4 20:03:07 2005
@@ -7,15 +7,14 @@
 //
 //*****************************************************************************
 
-#include <Python.h>
-#include <structmember.h>
-
 #include "../mud.h"
 #include "../utils.h"
 #include "../object.h"
 #include "../room.h"
 #include "../exit.h"
+#include "../world.h"
 
+#include "scripts.h"
 #include "pyroom.h"
 #include "pyobj.h"
 #include "pyplugs.h"
@@ -103,8 +102,11 @@
 
 PyObject *PyExit_getdest(PyObject *self, void *closure) {
   EXIT_DATA *ex = PyExit_AsExit((PyObject *)self);
-  if(ex != NULL) return Py_BuildValue("s", exitGetTo(ex));
-  else           return NULL;  
+  if(ex == NULL) return NULL;
+  else {
+    ROOM_DATA *dest = worldGetRoom(gameworld, exitGetTo(ex));
+    return Py_BuildValue("O", (dest ? roomGetPyFormBorrowed(dest) : Py_None));
+  }
 }
 
 PyObject *PyExit_getspotdiff(PyObject *self, void *closure) {
@@ -173,6 +175,17 @@
   else           return NULL;  
 }
 
+PyObject *PyExit_getroom(PyObject *self, void *closure) {
+  EXIT_DATA *ex = PyExit_AsExit((PyObject *)self);
+  if(ex == NULL) 
+    return NULL;
+  else
+    return Py_BuildValue("O", (exitGetRoom(ex) ? 
+			       roomGetPyFormBorrowed(exitGetRoom(ex)) : 
+			       Py_None));
+}
+
+
 
 //
 // Standard check to make sure the exit exists when trying to set a value for 
@@ -434,6 +447,7 @@
     exitSetName(ex, name);
   if(kwds != NULL)
     exitSetKeywords(ex, kwds);
+  exitSetClosable(ex, TRUE);
 
   // if we pulled up an opposite, we know we probably also got closed and locked
   // status. Not always, but close enough...
@@ -620,6 +634,8 @@
 			"true or false if the exit is closed.");
     PyExit_addGetSetter("is_locked", PyExit_getlocked, NULL,
 			"true or false if the exit is locked.");
+    PyExit_addGetSetter("room", PyExit_getroom, NULL,
+			"the room we are attached to.");
 
     // add all of the basic methods
     PyExit_addMethod("makedoor", PyExit_makedoor, METH_VARARGS,
diff -ruN ../nakedmudv3.0/src/scripts/pymud.c src/scripts/pymud.c
--- ../nakedmudv3.0/src/scripts/pymud.c	Fri Oct  7 14:15:55 2005
+++ src/scripts/pymud.c	Sun Dec  4 20:03:07 2005
@@ -34,6 +34,9 @@
 // global variables we have set.
 PyObject  *globals = NULL;
 
+// a list of methods to add to the mud module
+LIST *pymud_methods = NULL;
+
 
 
 //*****************************************************************************
@@ -205,12 +208,27 @@
   int found_type = FOUND_NONE;
   void    *found = generic_find(looker, arg, type, scope, all_ok, &found_type);
 
-  if(found_type == FOUND_CHAR)
-    return Py_BuildValue("Os", newPyChar(found), "char");
-  else if(found_type == FOUND_OBJ)
-    return Py_BuildValue("Os", newPyObj(found), "obj");
-  else if(found_type == FOUND_IN_OBJ)
-    return Py_BuildValue("Os", newPyObj(found), "in");
+  if(found_type == FOUND_CHAR) {
+    // were we searching for one type, or multiple types?
+    if(!strcasecmp("char", type_str))
+      return Py_BuildValue("O", charGetPyFormBorrowed(found));
+    else
+      return Py_BuildValue("Os", charGetPyFormBorrowed(found), "char");
+  }
+  else if(found_type == FOUND_OBJ) {
+    // were we searching for one type, or multiple types?
+    if(!strcasecmp("obj", type_str))
+      return Py_BuildValue("O", objGetPyFormBorrowed(found));
+    else
+      return Py_BuildValue("Os", objGetPyFormBorrowed(found), "obj");
+  }
+  else if(found_type == FOUND_IN_OBJ) {
+    // were we searching for one type, or multiple types?
+    if(!strcasecmp("in", type_str))
+      return Py_BuildValue("O", objGetPyFormBorrowed(found));
+    else
+      return Py_BuildValue("Os", objGetPyFormBorrowed(found), "in");
+  }
   // now it gets a bit more tricky... we have to see what other bit was set
   else if(found_type == FOUND_LIST) {
     PyObject         *list = PyList_New(0);
@@ -218,15 +236,17 @@
     void        *one_found = NULL;
     if(IS_SET(type, FIND_TYPE_CHAR)) {
       ITERATE_LIST(one_found, found_i)
-	PyList_Append(list, newPyChar(one_found));
+	PyList_Append(list, charGetPyFormBorrowed(one_found));
     }
     else if(IS_SET(type, FIND_TYPE_OBJ | FIND_TYPE_IN_OBJ)) {
       ITERATE_LIST(one_found, found_i)
-	PyList_Append(list, newPyChar(one_found));
+	PyList_Append(list, charGetPyFormBorrowed(one_found));
     }
     deleteListIterator(found_i);
     deleteList(found);
-    return Py_BuildValue("Os", list, "list");
+    PyObject *retval = Py_BuildValue("Os", list, "list");
+    Py_DECREF(list);
+    return retval;
   }
 
   // nothing was found...
@@ -362,45 +382,74 @@
     return false_act;
 }
 
+//
+// returns whether or not two database keys have the same name. Locale sensitive
+PyObject *mud_keys_equal(PyObject *self, PyObject *args) {
+  char *key1 = NULL;
+  char *key2 = NULL;
+  if(!PyArg_ParseTuple(args, "ss", &key1, &key2)) {
+    PyErr_Format(PyExc_TypeError, "keys_equal takes two string arguments");
+    return NULL;
+  }
+
+  char *fullkey1 = strdup(get_fullkey_relative(key1, get_script_locale()));
+  char *fullkey2 = strdup(get_fullkey_relative(key2, get_script_locale()));
+  bool        ok = !strcasecmp(fullkey1, fullkey2);
+  free(fullkey1);
+  free(fullkey2);
+  return Py_BuildValue("i", ok);
+}
+
 
 
 //*****************************************************************************
 // MUD module
 //*****************************************************************************
-PyMethodDef mud_module_methods[] = {
-    {"get_global",  mud_get_global, METH_VARARGS,
-     "Get the value of a global variable."},
-    {"set_global",  mud_set_global, METH_VARARGS,
-     "Set the value of a global variable."},
-    {"erase_global",  mud_erase_global, METH_VARARGS,
-     "Erase the value of a global variable."},
-    {"add_cmd", mud_add_cmd, METH_VARARGS,
-     "Add a new command to the game."},
-    {"message", mud_message, METH_VARARGS,
-     "plugs into the message() function from inform.h" },
-    {"format_string", mud_format_string, METH_VARARGS,
-     "format a string to be 80 chars wide and indented. Like a desc."},
-    {"generic_find",  mud_generic_find, METH_VARARGS,
-     "Python wrapper around the generic_find() function"},
-    {"extract", mud_extract, METH_VARARGS,
-    "extracts an object or character from the game. This method is dangerous, "
-    "since the object may still be needed in whichever function called the "
-    "script that activated this method" },
-    {"ite", mud_ite, METH_VARARGS,
-     "A functional form of an if-then-else statement. Takes 2 arguments "
-     "(condition, if action) and an optional third (else action). If no else "
-     "action is specified and the condition is false, None is returned." },
-    {NULL, NULL, 0, NULL}        /* Sentinel */
-};
+void PyMud_addMethod(const char *name, void *f, int flags, const char *doc) {
+  // make sure our list of methods is created
+  if(pymud_methods == NULL) pymud_methods = newList();
+
+  // make the Method def
+  PyMethodDef *def = calloc(1, sizeof(PyMethodDef));
+  def->ml_name     = strdup(name);
+  def->ml_meth     = (PyCFunction)f;
+  def->ml_flags    = flags;
+  def->ml_doc      = (doc ? strdup(doc) : NULL);
+  listPut(pymud_methods, def);
+}
 
 
 PyMODINIT_FUNC
 init_PyMud(void) {
-  PyObject *m;
+  // add all of our methods
+  PyMud_addMethod("get_global", mud_get_global, METH_VARARGS,
+		  "Get the value of a global variable.");
+  PyMud_addMethod("set_global", mud_set_global, METH_VARARGS,
+		  "Set the value of a global variable.");
+  PyMud_addMethod("erase_global",  mud_erase_global, METH_VARARGS,
+		  "Erase the value of a global variable.");
+  PyMud_addMethod("add_cmd", mud_add_cmd, METH_VARARGS,
+		  "Add a new command to the game.");
+  PyMud_addMethod("message", mud_message, METH_VARARGS,
+		  "plugs into the message() function from inform.h");
+  PyMud_addMethod("format_string", mud_format_string, METH_VARARGS,
+		  "format a string to be 80 chars wide and indented.");
+  PyMud_addMethod("generic_find",  mud_generic_find, METH_VARARGS,
+		  "Python wrapper around the generic_find() function");
+  PyMud_addMethod("extract", mud_extract, METH_VARARGS,
+		  "extracts an object or character from the game.");
+  PyMud_addMethod("keys_equal", mud_keys_equal, METH_VARARGS,
+		  "Returns whether or not two db keys are equal, given the ."
+		  "locale that the script is running in.");
+  PyMud_addMethod("ite", mud_ite, METH_VARARGS,
+		  "A functional form of an if-then-else statement. Takes 2 "
+		  "arguments (condition, if action) and an optional third "
+		  "(else action). If no else action is specified and the "
+		  "condition is false, None is returned.");
+
+  Py_InitModule3("mud", makePyMethods(pymud_methods),
+		 "The mud module, for all MUD misc mud utils.");
 
   globals = PyDict_New();
   Py_INCREF(globals);
-
-  m = Py_InitModule3("mud", mud_module_methods,
-		     "The mud module, for all MUD misc mud utils.");
 }
diff -ruN ../nakedmudv3.0/src/scripts/pymud.h src/scripts/pymud.h
--- ../nakedmudv3.0/src/scripts/pymud.h	Fri Oct  7 14:15:55 2005
+++ src/scripts/pymud.h	Sun Dec  4 20:03:07 2005
@@ -14,4 +14,12 @@
 PyMODINIT_FUNC
 init_PyMud(void);
 
+//
+// Adds a new method function (i.e. void *f) to the Mud module. Name is the name
+// of the function, f is the PyCFunction implementing the new method, flags is
+// the type of method beings used (almost always METH_VARARGS), and doc is an
+// (optional) description of what the method does. For examples on how to add
+// new methods, see pymud.c
+void PyMud_addMethod(const char *name, void *f, int flags, const char *doc);
+
 #endif //__PYMUD_H
diff -ruN ../nakedmudv3.0/src/scripts/pyobj.c src/scripts/pyobj.c
--- ../nakedmudv3.0/src/scripts/pyobj.c	Fri Oct  7 14:15:55 2005
+++ src/scripts/pyobj.c	Sun Dec  4 20:03:07 2005
@@ -33,6 +33,7 @@
 // mandatory modules
 //*****************************************************************************
 #include "../items/items.h"
+#include "../items/worn.h"
 
 
 
@@ -172,9 +173,11 @@
   
   // for each obj in the contentory, add it to the Python list
   ITERATE_LIST(cont, cont_i)
-    PyList_Append(list, newPyObj(cont));
+    PyList_Append(list, objGetPyFormBorrowed(cont));
   deleteListIterator(cont_i);
-  return Py_BuildValue("O", list);
+  PyObject *retval = Py_BuildValue("O", list);
+  Py_DECREF(list);
+  return retval;
 }
 
 PyObject *PyObj_getchars(PyObj *self, PyObject *args) {
@@ -188,9 +191,11 @@
   
   // for each obj in the contentory, add it to the Python list
   ITERATE_LIST(ch, char_i)
-    PyList_Append(list, newPyChar(ch));
+    PyList_Append(list, charGetPyFormBorrowed(ch));
   deleteListIterator(char_i);
-  return Py_BuildValue("O", list);
+  PyObject *retval = Py_BuildValue("O", list);
+  Py_DECREF(list);
+  return retval;
 }
 
 PyObject *PyObj_getcarrier(PyObj *self, void *closure) {
@@ -199,7 +204,7 @@
     return NULL;
   if(objGetCarrier(obj) == NULL)
     return Py_None;
-  return Py_BuildValue("O", newPyChar(objGetCarrier(obj)));
+  return Py_BuildValue("O", charGetPyFormBorrowed(objGetCarrier(obj)));
 }
 
 PyObject *PyObj_getroom(PyObj *self, void *closure) {
@@ -208,7 +213,7 @@
     return NULL;
   if(objGetRoom(obj) == NULL)
     return Py_None;
-  return Py_BuildValue("O", newPyRoom(objGetRoom(obj)));
+  return Py_BuildValue("O", roomGetPyFormBorrowed(objGetRoom(obj)));
 }
 
 PyObject *PyObj_getcontainer(PyObj *self, void *closure) {
@@ -217,7 +222,7 @@
     return NULL;
   if(objGetContainer(obj) == NULL)
     return Py_None;
-  return Py_BuildValue("O", newPyObj(objGetContainer(obj)));
+  return Py_BuildValue("O", objGetPyFormBorrowed(objGetContainer(obj)));
 }
 
 //
@@ -743,16 +748,25 @@
   else if(cont != NULL)
     obj_to_obj(obj, cont);
   else if(ch != NULL) {
-    // see if we're trying to equip the object
-    if(equip_to && !try_equip(ch, obj, equip_to))
-      obj_to_char(obj, ch);
+    // if we have supplied locations, equip to those
+    if(equip_to && *equip_to) {
+      if(!try_equip(ch, obj, equip_to, NULL))
+	obj_to_char(obj, ch);
+    }
+
+    // otherwise, assume it's worn equipemnt
+    else if(objIsType(obj, "worn")) {
+      if(!try_equip(ch, obj, NULL, wornGetPositions(obj)))
+	obj_to_char(obj, ch);
+    }
+
+    // failed. Just give it to us
     else
       obj_to_char(obj, ch);
   }
 
   // create a python object for the new obj, and return it
-  PyObj *py_obj = (PyObj *)newPyObj(obj);
-  return Py_BuildValue("O", py_obj);
+  return Py_BuildValue("O", objGetPyFormBorrowed(obj));
 }
 
 
@@ -850,7 +864,7 @@
     OBJ_DATA *obj    = find_obj(looker_ch, list, count, name, NULL, 
 				(looker_ch ? TRUE : FALSE));
     PyObject *py_obj = Py_None;
-    if(obj) py_obj = newPyObj(obj);
+    if(obj) py_obj = objGetPyFormBorrowed(obj);
     return Py_BuildValue("O", py_obj);
   }
   // otherwise, return everything that meets our critereon
@@ -908,7 +922,7 @@
     OBJ_DATA *obj    = find_obj(looker_ch, list, count, NULL, key,
 				(looker_ch ? TRUE : FALSE));
     PyObject *py_obj = Py_None;
-    if(obj) py_obj = newPyObj(obj);
+    if(obj) py_obj = objGetPyFormBorrowed(obj);
     return Py_BuildValue("O", py_obj);
   }
   // otherwise, return everything that meets our critereon
diff -ruN ../nakedmudv3.0/src/scripts/pyplugs.c src/scripts/pyplugs.c
--- ../nakedmudv3.0/src/scripts/pyplugs.c	Fri Oct  7 14:15:55 2005
+++ src/scripts/pyplugs.c	Sun Dec  4 20:03:07 2005
@@ -222,31 +222,36 @@
     return chrRetval;
 }
 
+PyGetSetDef *makePyGetSetters(LIST *getsetters) {
+  PyGetSetDef *getsets = calloc(listSize(getsetters)+1,sizeof(PyGetSetDef));
+  LIST_ITERATOR  *gs_i = newListIterator(getsetters);
+  PyGetSetDef      *gs = NULL;
+  int i                = 0;
+  ITERATE_LIST(gs, gs_i) {
+    getsets[i] = *gs;
+    i++;
+  } deleteListIterator(gs_i);
+  return getsets;
+}
+
+PyMethodDef *makePyMethods(LIST *methods) {
+  PyMethodDef  *meth = calloc(listSize(methods)+1, sizeof(PyMethodDef));
+  LIST_ITERATOR *m_i = newListIterator(methods);
+  PyMethodDef     *m = NULL;
+  int i              = 0;
+  ITERATE_LIST(m, m_i) {
+    meth[i] = *m;
+    i++;
+  } deleteListIterator(m_i);
+  return meth;
+}
 
 void makePyType(PyTypeObject *type, LIST *getsetters, LIST *methods) {
   // build up the array of getsetters for this object
-  if(getsetters != NULL) {
-    PyGetSetDef *getsets = calloc(listSize(getsetters)+1,sizeof(PyGetSetDef));
-    LIST_ITERATOR  *gs_i = newListIterator(getsetters);
-    PyGetSetDef      *gs = NULL;
-    int i                = 0;
-    ITERATE_LIST(gs, gs_i) {
-      getsets[i] = *gs;
-      i++;
-    } deleteListIterator(gs_i);
-    type->tp_getset = getsets;
-  }
+  if(getsetters != NULL)
+    type->tp_getset = makePyGetSetters(getsetters);
   
   // build up the array of methods for this object
-  if(methods != NULL) {
-    PyMethodDef *meth  = calloc(listSize(methods)+1, sizeof(PyMethodDef));
-    LIST_ITERATOR *m_i = newListIterator(methods);
-    PyMethodDef     *m = NULL;
-    int i              = 0;
-    ITERATE_LIST(m, m_i) {
-      meth[i] = *m;
-      i++;
-    } deleteListIterator(m_i);
-    type->tp_methods = meth;
-  }
+  if(methods != NULL)
+    type->tp_methods = makePyMethods(methods);
 }
diff -ruN ../nakedmudv3.0/src/scripts/pyplugs.h src/scripts/pyplugs.h
--- ../nakedmudv3.0/src/scripts/pyplugs.h	Fri Oct  7 14:15:55 2005
+++ src/scripts/pyplugs.h	Sun Dec  4 20:03:07 2005
@@ -25,4 +25,12 @@
 // lists can each be NULL if there are no getsetters or methods, respectively
 void makePyType(PyTypeObject *type, LIST *getsetters, LIST *methods);
 
+//
+// makes an array of get/setters
+PyGetSetDef *makePyGetSetters(LIST *getsetters);
+
+//
+// makes an array of python methods
+PyMethodDef *makePyMethods(LIST *methods);
+
 #endif // PYPLUGS_H
diff -ruN ../nakedmudv3.0/src/scripts/pyroom.c src/scripts/pyroom.c
--- ../nakedmudv3.0/src/scripts/pyroom.c	Fri Oct  7 14:15:55 2005
+++ src/scripts/pyroom.c	Sun Dec  4 20:03:07 2005
@@ -136,7 +136,9 @@
   LIST_ITERATOR *ex_i = newListIterator(ex_list);
   char           *dir = NULL;
   ITERATE_LIST(dir, ex_i) {
-    PyList_Append(list, Py_BuildValue("s", dir));
+    PyObject    *cont = Py_BuildValue("s", dir);
+    PyList_Append(list, cont);
+    Py_DECREF(cont);
   } deleteListIterator(ex_i);
   deleteListWith(ex_list, free);
   return list;
@@ -153,9 +155,11 @@
 
     // for each char in the room list, add him to a Python list
     ITERATE_LIST(ch, char_i)
-      PyList_Append(list, newPyChar(ch));
+      PyList_Append(list, charGetPyFormBorrowed(ch));
     deleteListIterator(char_i);
-    return Py_BuildValue("O", list);
+    PyObject *retval = Py_BuildValue("O", list);
+    Py_DECREF(list);
+    return retval;
   }
 }
 
@@ -170,12 +174,20 @@
 
     // for each obj in the room list, add him to a Python list
     ITERATE_LIST(obj, obj_i)
-      PyList_Append(list, newPyObj(obj));
+      PyList_Append(list, objGetPyFormBorrowed(obj));
     deleteListIterator(obj_i);
-    return Py_BuildValue("O", list);
+    PyObject *retval = Py_BuildValue("O", list);
+    Py_DECREF(list);
+    return retval;
   }
 }
 
+PyObject *PyRoom_getbits(PyRoom *self, void *closure) {
+  ROOM_DATA *room = PyRoom_AsRoom((PyObject *)self);
+  if(room!=NULL) return Py_BuildValue("s", bitvectorGetBits(roomGetBits(room)));
+  else           return NULL;
+}
+
 
 //
 // Standard check to make sure the room exists when trying to set a value for 
@@ -248,6 +260,24 @@
   return 0;
 }
 
+int PyRoom_setbits(PyRoom *self, PyObject *value, void *closure) {
+  if(value == NULL) {
+    PyErr_Format(PyExc_TypeError, "Cannot delete room's bits");
+    return -1;
+  }
+  
+  if (!PyString_Check(value)) {
+    PyErr_Format(PyExc_TypeError, "Room bits must be strings");
+    return -1;
+  }
+
+  ROOM_DATA *room;
+  PYROOM_CHECK_ROOM_EXISTS(self->uid, room);
+  bitClear(roomGetBits(room));
+  bitSet(roomGetBits(room), PyString_AsString(value));
+  return 0;
+}
+
 
 
 //*****************************************************************************
@@ -326,8 +356,12 @@
     cdir = dirGetName(dirGetAbbrevNum(dir));
 
   EXIT_DATA *exit = roomGetExit(room, cdir);
-  if(exit != NULL)
-    return Py_BuildValue("O", newPyExit(exit));
+  if(exit != NULL) {
+    PyObject   *pyex = newPyExit(exit);
+    PyObject *retval = Py_BuildValue("O", pyex);
+    Py_DECREF(pyex);
+    return retval;
+  }
   else
     return Py_None;
 }
@@ -435,7 +469,10 @@
 			"player", TRUE, TRUE));
   }
 
-  return Py_BuildValue("O", newPyExit(exit));
+  PyObject   *pyex = newPyExit(exit);
+  PyObject *retval = Py_BuildValue("O", pyex);
+  Py_DECREF(pyex);
+  return retval;
 }
 
 
@@ -656,7 +693,7 @@
 			"the room's name");
     PyRoom_addGetSetter("desc",    PyRoom_getdesc,     PyRoom_setdesc, 
 			"the room's desc");
-    PyRoom_addGetSetter("class",   PyRoom_getclass,    NULL, 
+    PyRoom_addGetSetter("proto",   PyRoom_getclass,    NULL, 
 			"The room's class");
     PyRoom_addGetSetter("chars",   PyRoom_getchars,    NULL, 
 			"chars in the room");
@@ -670,6 +707,8 @@
 			"the room's uid");
     PyRoom_addGetSetter("terrain", PyRoom_getterrain,  PyRoom_setterrain,
 			"the room's terrain type");
+    PyRoom_addGetSetter("bits",    PyRoom_getbits,     PyRoom_setbits,
+			"the room's bits");
 
     // add all of the basic methods
     PyRoom_addMethod("attach", PyRoom_attach, METH_VARARGS,
diff -ruN ../nakedmudv3.0/src/scripts/pystorage.c src/scripts/pystorage.c
--- ../nakedmudv3.0/src/scripts/pystorage.c	Fri Oct  7 14:15:55 2005
+++ src/scripts/pystorage.c	Sun Dec  4 20:03:07 2005
@@ -76,11 +76,16 @@
   PyObject             *list = PyList_New(0);
 
   // add in all of the elements
-  while( (set = storage_list_next(set_list)) != NULL)
-    PyList_Append(list, newPyStorageSet(set));
+  while( (set = storage_list_next(set_list)) != NULL) {
+    PyObject *pyset = newPyStorageSet(set);
+    PyList_Append(list, pyset);
+    Py_DECREF(pyset);
+  }
 
   // return the new list
-  return Py_BuildValue("O", list);
+  PyObject *retval = Py_BuildValue("O", list);
+  Py_DECREF(list);
+  return retval;
 }
 
 //
@@ -269,24 +274,30 @@
 // read a storage list from the storage set
 PyObject *PyStorageSet_readList  (PyObject *self, PyObject *args) { 
   char *key = PyStorageSet_readParseKey(args);
-  if(key != NULL) 
-    return Py_BuildValue("O", 
-			 newPyStorageList(read_list(((PyStorageSet*)self)->set, 
-						   key)));
-  else
+  if(key == NULL)
     return NULL;
+  else {
+    PyObject *pylist =
+      newPyStorageList(read_list(((PyStorageSet*)self)->set, key));
+    PyObject *retval = Py_BuildValue("O", pylist);
+    Py_DECREF(pylist);
+    return retval;
+  }
 }
 
 //
 // read a storage set from within the set
 PyObject *PyStorageSet_readSet   (PyObject *self, PyObject *args) { 
   char *key = PyStorageSet_readParseKey(args);
-  if(key != NULL) 
-    return Py_BuildValue("O", 
-			 newPyStorageSet(read_set(((PyStorageSet *)self)->set, 
-						  key)));
-  else
+  if(key == NULL)
     return NULL;
+  else {
+    PyObject *pyset = 
+      newPyStorageSet(read_set(((PyStorageSet *)self)->set, key));
+    PyObject *retval = Py_BuildValue("O", pyset);
+    Py_DECREF(pyset);
+    return retval;
+  }
 }
 
 
